#include <sys/types.h>	/* notendige ... */
#include <dirent.h>	/* ... Includes */
#include <stdio.h>

int main(int argc, char **argv) {
	DIR *dir;
	struct dirent *entry;

	/* falls nicht genau ein Argument => Usage */
	if (argc != 2) {
		fprintf(stderr, "Usage: %s <dir>\n", argv[0]);
		exit(1);
	}

	/*
	 * Verzeichnis oeffnen;
	 * Rueckgabewert ist Zeiger, der die Verbindung
	 * repraesentiert; ist der Zeiger NULL, so liegt
	 * ein Fehler vor
	 */
	if ((dir = opendir(argv[1])) == NULL) {
		perror("opendir()");	/* Fehler ausgeben */
		exit(2);		/* Prog. mit Exit-Status 2 terminieren */
	}

	/*
	 * Eintrag fuer Eintrag lesen;
	 * NULL signalisiert Ende bzw. Fehler
	 */
	while ((entry = readdir(dir)) != NULL) {
		/*
		 * Element d_name der Struktur, auf
		 * die entry zeigt ist der Name des Verzeichnis-
		 * eintrags
		 *
		 * (Es gibt immer die beiden Eintraege "." (= akt. Verz.) und
		 *  ".." (= Vater-Verz.)!! => VORSICHT!)
		 */
		puts(entry->d_name);
	}

	/* Verbindung wieder sauber beenden */
	closedir(dir);

	exit(0);
}
