#include <sys/stat.h>	// fuer struct stat
#include <unistd.h>	// fuer stat(.)
#include <time.h>	// fuer ctime(.)
#include <stdio.h>

int main(int argc, char **argv) {
    int i; char *s;
    struct stat statbuf;
    for (i = 1; i < argc; i++) {
	printf("Datei \"%s\":\n", argv[i]);
	
	if (lstat(argv[i], &statbuf) < 0)
	    perror("stat()"), exit(1);	// Abbruch im Fehlerfall
	
	    /* ctime(.) erzeugt aus der Datenstruktur
	     * time_t einen String */
	printf("	letzter Zugriff: %s",
		ctime(&statbuf.st_atime));
	/* statbuf.st_mtime und statbuf.st_ctime
	 * koennen analog behandelt werden. */

	switch (statbuf.st_mode & S_IFMT) {
	    case S_IFREG  : s = "normale Datei"; break;
	    case S_IFDIR  : s = "Verzeichnis"; break;
	    case S_IFCHR  : s = "zeichenorient. Geraet"; break;
	    case S_IFBLK  : s = "blockorient. Geraet"; break;
	    case S_IFLNK  : s = "symbolischer Link"; break;
	    case S_IFIFO  : s = "FIFO"; break;
	    case S_IFSOCK : s = "Socket"; break;
	    default:	    s = "_unbekannt_"; break;
	}
	printf("	Datei-Typ: %s\n", s);
    }
    return 0;
}
